Index: applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/gui/StreetsidePreferenceSettingTest.java
===================================================================
--- applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/gui/StreetsidePreferenceSettingTest.java	(revision 36193)
+++ applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/gui/StreetsidePreferenceSettingTest.java	(revision 36194)
@@ -1,2 +1,3 @@
+// License: GPL. For details, see LICENSE file.
 package org.openstreetmap.josm.plugins.streetside.gui;
 
@@ -22,85 +23,97 @@
 @Disabled
 class StreetsidePreferenceSettingTest {
-  // TODO: repair broken unit test from Mapillary
-  @Test
-  void testAddGui() {
-    if (GraphicsEnvironment.isHeadless()) {
-      return;
+    // TODO: repair broken unit test from Mapillary
+    @Test
+    void testAddGui() {
+        if (GraphicsEnvironment.isHeadless()) {
+            return;
+        }
+        PreferenceTabbedPane tabs = new PreferenceTabbedPane();
+        tabs.buildGui();
+        int displayTabs = tabs.getDisplayPreference().getTabPane().getTabCount();
+        StreetsidePreferenceSetting setting = new StreetsidePreferenceSetting();
+        setting.addGui(tabs);
+        assertEquals(displayTabs + 1, tabs.getDisplayPreference().getTabPane().getTabCount());
+        assertEquals(tabs.getDisplayPreference(), setting.getTabPreferenceSetting(tabs));
     }
-    PreferenceTabbedPane tabs = new PreferenceTabbedPane();
-    tabs.buildGui();
-    int displayTabs = tabs.getDisplayPreference().getTabPane().getTabCount();
-    StreetsidePreferenceSetting setting = new StreetsidePreferenceSetting();
-    setting.addGui(tabs);
-    assertEquals(displayTabs + 1, tabs.getDisplayPreference().getTabPane().getTabCount());
-    assertEquals(tabs.getDisplayPreference(), setting.getTabPreferenceSetting(tabs));
-  }
 
-  @Test
-  void testIsExpert() {
-    Assertions.assertFalse(new StreetsidePreferenceSetting().isExpert());
-  }
+    @Test
+    void testIsExpert() {
+        Assertions.assertFalse(new StreetsidePreferenceSetting().isExpert());
+    }
 
-  @SuppressWarnings("unchecked")
-  @Test
-  void testOk() {
-    StreetsidePreferenceSetting settings = new StreetsidePreferenceSetting();
+    @SuppressWarnings("unchecked")
+    @Test
+    void testOk() {
+        StreetsidePreferenceSetting settings = new StreetsidePreferenceSetting();
 
-    // Initialize the properties with some arbitrary value to make sure they are not unset
-    new StringProperty("streetside.display-hour", "default").put("arbitrary");
-    new StringProperty("streetside.format-24", "default").put("arbitrary");
-    new StringProperty("streetside.move-to-picture", "default").put("arbitrary");
-    new StringProperty("streetside.hover-enabled", "default").put("arbitrary");
-    new StringProperty("streetside.download-mode", "default").put("arbitrary");
-    new StringProperty("streetside.prefetch-image-count", "default").put("arbitrary");
+        // Initialize the properties with some arbitrary value to make sure they are not unset
+        new StringProperty("streetside.display-hour", "default").put("arbitrary");
+        new StringProperty("streetside.format-24", "default").put("arbitrary");
+        new StringProperty("streetside.move-to-picture", "default").put("arbitrary");
+        new StringProperty("streetside.hover-enabled", "default").put("arbitrary");
+        new StringProperty("streetside.download-mode", "default").put("arbitrary");
+        new StringProperty("streetside.prefetch-image-count", "default").put("arbitrary");
 
-    // Test checkboxes
-    settings.ok();
-    assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "displayHour"), "streetside.display-hour");
-    assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "format24"), "streetside.format-24");
-    assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "moveTo"), "streetside.move-to-picture");
-    assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "hoverEnabled"), "streetside.hover-enabled");
-    assertEquals(String.valueOf(((SpinnerNumberModel) getPrivateFieldValue(settings, "preFetchSize")).getNumber().intValue()), new StringProperty("streetside.prefetch-image-count", "default").get());
+        // Test checkboxes
+        settings.ok();
+        assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "displayHour"),
+                "streetside.display-hour");
+        assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "format24"),
+                "streetside.format-24");
+        assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "moveTo"),
+                "streetside.move-to-picture");
+        assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "hoverEnabled"),
+                "streetside.hover-enabled");
+        assertEquals(
+                String.valueOf(
+                        ((SpinnerNumberModel) getPrivateFieldValue(settings, "preFetchSize")).getNumber().intValue()),
+                new StringProperty("streetside.prefetch-image-count", "default").get());
 
-    // Toggle state of the checkboxes
-    toggleCheckbox((JCheckBox) getPrivateFieldValue(settings, "displayHour"));
-    toggleCheckbox((JCheckBox) getPrivateFieldValue(settings, "format24"));
-    toggleCheckbox((JCheckBox) getPrivateFieldValue(settings, "moveTo"));
-    toggleCheckbox((JCheckBox) getPrivateFieldValue(settings, "hoverEnabled"));
-    ((SpinnerNumberModel) getPrivateFieldValue(settings, "preFetchSize")).setValue(73);
+        // Toggle state of the checkboxes
+        toggleCheckbox((JCheckBox) getPrivateFieldValue(settings, "displayHour"));
+        toggleCheckbox((JCheckBox) getPrivateFieldValue(settings, "format24"));
+        toggleCheckbox((JCheckBox) getPrivateFieldValue(settings, "moveTo"));
+        toggleCheckbox((JCheckBox) getPrivateFieldValue(settings, "hoverEnabled"));
+        ((SpinnerNumberModel) getPrivateFieldValue(settings, "preFetchSize")).setValue(73);
 
-    // Test the second state of the checkboxes
-    settings.ok();
-    assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "displayHour"), "streetside.display-hour");
-    assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "format24"), "streetside.format-24");
-    assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "moveTo"), "streetside.move-to-picture");
-    assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "hoverEnabled"), "streetside.hover-enabled");
-    assertEquals(String.valueOf(((SpinnerNumberModel) getPrivateFieldValue(settings, "preFetchSize")).getNumber().intValue()), new StringProperty("streetside.prefetch-image-count", "default").get());
+        // Test the second state of the checkboxes
+        settings.ok();
+        assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "displayHour"),
+                "streetside.display-hour");
+        assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "format24"),
+                "streetside.format-24");
+        assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "moveTo"),
+                "streetside.move-to-picture");
+        assertPropertyMatchesCheckboxSelection((JCheckBox) getPrivateFieldValue(settings, "hoverEnabled"),
+                "streetside.hover-enabled");
+        assertEquals(
+                String.valueOf(
+                        ((SpinnerNumberModel) getPrivateFieldValue(settings, "preFetchSize")).getNumber().intValue()),
+                new StringProperty("streetside.prefetch-image-count", "default").get());
 
-    // Test combobox
-    for (int i = 0; i < ((JComboBox<String>) getPrivateFieldValue(settings, "downloadModeComboBox")).getItemCount(); i++) {
-      ((JComboBox<String>) getPrivateFieldValue(settings, "downloadModeComboBox")).setSelectedIndex(i);
-      settings.ok();
-      assertEquals(
-        new StringProperty("streetside.download-mode", "default").get(),
-        DOWNLOAD_MODE.fromLabel(
-          ((JComboBox<String>) getPrivateFieldValue(settings, "downloadModeComboBox")).getSelectedItem().toString()
-        ).getPrefId()
-      );
+        // Test combobox
+        for (int i = 0; i < ((JComboBox<String>) getPrivateFieldValue(settings, "downloadModeComboBox"))
+                .getItemCount(); i++) {
+            ((JComboBox<String>) getPrivateFieldValue(settings, "downloadModeComboBox")).setSelectedIndex(i);
+            settings.ok();
+            assertEquals(new StringProperty("streetside.download-mode", "default").get(),
+                    DOWNLOAD_MODE.fromLabel(((JComboBox<String>) getPrivateFieldValue(settings, "downloadModeComboBox"))
+                            .getSelectedItem().toString()).getPrefId());
+        }
     }
-  }
 
-  /**
-   * Checks, if a certain {@link BooleanProperty} (identified by the {@code propName} attribute) matches the selected-state of the given {@link JCheckBox}
-   * @param cb the {@link JCheckBox}, which should be checked against the {@link BooleanProperty}
-   * @param propName the name of the property against which the selected-state of the given {@link JCheckBox} should be checked
-   */
-  private static void assertPropertyMatchesCheckboxSelection(JCheckBox cb, String propName) {
-    assertEquals(cb.isSelected(), new BooleanProperty(propName, !cb.isSelected()).get());
-  }
+    /**
+     * Checks, if a certain {@link BooleanProperty} (identified by the {@code propName} attribute) matches the selected-state of the given {@link JCheckBox}
+     * @param cb the {@link JCheckBox}, which should be checked against the {@link BooleanProperty}
+     * @param propName the name of the property against which the selected-state of the given {@link JCheckBox} should be checked
+     */
+    private static void assertPropertyMatchesCheckboxSelection(JCheckBox cb, String propName) {
+        assertEquals(cb.isSelected(), new BooleanProperty(propName, !cb.isSelected()).get());
+    }
 
-  private static void toggleCheckbox(JCheckBox jcb) {
-    jcb.setSelected(!jcb.isSelected());
-  }
+    private static void toggleCheckbox(JCheckBox jcb) {
+        jcb.setSelected(!jcb.isSelected());
+    }
 
 }
Index: applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/history/StreetsideRecordTest.java
===================================================================
--- applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/history/StreetsideRecordTest.java	(revision 36193)
+++ applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/history/StreetsideRecordTest.java	(revision 36194)
@@ -1,5 +1,4 @@
 // License: GPL. For details, see LICENSE file.
 package org.openstreetmap.josm.plugins.streetside.history;
-
 
 import static org.junit.jupiter.api.Assertions.assertEquals;
@@ -35,201 +34,183 @@
 class StreetsideRecordTest {
 
-  private StreetsideRecord record;
-  private StreetsideImage img1;
-  private StreetsideImage img2;
-  private StreetsideImage img3;
-
-  /**
-   * Creates a new {@link StreetsideRecord} object and 3 {@link StreetsideImage}
-   * objects.
-   */
-  @BeforeEach
-  public void setUp() {
-    record = new StreetsideRecord();
-    img1 = new StreetsideImage("key1__________________", new LatLon(0.1, 0.1), 0.1);
-    img2 = new StreetsideImage("key2__________________", new LatLon(0.2, 0.2), 0.2);
-    img3 = new StreetsideImage("key3__________________", new LatLon(0.3, 0.3), 0.3);
-    if (StreetsideLayer.hasInstance() && StreetsideLayer.getInstance().getData().getImages().size() >= 1) {
-      StreetsideLayer.getInstance().getData().getImages().clear();
-    }
-  }
-
-  /**
-   * Test commands in general.
-   */
-  @Test
-  void testCommand() {
-    StreetsideCommand cmd12 = new CommandMove(
-            new ConcurrentSkipListSet<>(Arrays.asList(img1, img2)),
-            0.1, 0.1);
-    StreetsideCommand cmd23 = new CommandMove(
-            new ConcurrentSkipListSet<>(Arrays.asList(img2, img3)),
-            0.1, 0.1);
-    StreetsideCommand cmd13 = new CommandMove(
-            new ConcurrentSkipListSet<>(Arrays.asList(img1, img3)),
-            0.1, 0.1);
-    StreetsideCommand cmd1 = new CommandMove(
-            new ConcurrentSkipListSet<>(Collections.singletonList(img1)), 0.1, 0.1);
-    StreetsideCommand cmd31 = new CommandMove(
-            new ConcurrentSkipListSet<>(Arrays.asList(img3, img1)),
-            0.2, 0.2);
-    record.addCommand(cmd12);
-    record.addCommand(cmd23);
-
-    assertEquals(1, record.position);
-    assertEquals(2, record.commandList.size());
-
-    record.undo();
-
-    assertEquals(0, record.position);
-    assertEquals(2, record.commandList.size());
-
-    record.addCommand(cmd1);
-
-    assertEquals(1, record.position);
-
-    record.addCommand(cmd13);
-
-    assertEquals(2, record.position);
-    assertEquals(3, record.commandList.size());
-
-    record.undo();
-    record.redo();
-
-    assertEquals(2, record.position);
-    assertEquals(3, record.commandList.size());
-
-    record.addCommand(cmd31);
-
-    assertEquals(2, record.position);
-    assertEquals(3, record.commandList.size());
-
-    record.addCommand(cmd1);
-
-    assertEquals(3, record.position);
-    assertEquals(4, record.commandList.size());
-  }
-
-  /**
-   * Tests {@link CommandMove} class.
-   */
-  @Test
-  void testCommandMove() {
-    CommandMove cmd1 = new CommandMove(
-            new ConcurrentSkipListSet<>(Arrays.asList(img1, img2)),
-            0.1, 0.1);
-    CommandMove cmd2 = new CommandMove(
-            new ConcurrentSkipListSet<>(Arrays.asList(img1, img2)),
-            0.1, 0.1);
-
-    record.addCommand(cmd1);
-
-    assertEquals(0.1, img1.getMovingLatLon().lat(), 0.01);
-
-    record.undo();
-
-    assertEquals(0.0, img1.getMovingLatLon().lat(), 0.01);
-
-    record.redo();
-
-    assertEquals(0.1, img1.getMovingLatLon().lat(), 0.01);
-
-    record.addCommand(cmd2);
-    record.undo();
-
-    assertEquals(-0.1, img1.getMovingLatLon().lat(), 0.01);
-
-    record.redo();
-
-    assertEquals(0.1, img1.getMovingLatLon().lat(), 0.01);
-  }
-
-  /**
-   * Tests {@link CommandTurn} class.
-   */
-  @Test
-  void testCommandTurn() {
-    CommandTurn cmd1 = new CommandTurn(
-            new ConcurrentSkipListSet<>(Arrays.asList(img1, img2)),
-            0.2);
-    CommandTurn cmd2 = new CommandTurn(
-            new ConcurrentSkipListSet<>(Arrays.asList(img1, img2)),
-            0.1);
-
-    record.addCommand(cmd1);
-    record.undo();
-
-    assertEquals(-0.1, img1.getMovingHe(), 0.01);
-
-    record.redo();
-
-    assertEquals(0.1, img1.getMovingHe(), 0.01);
-
-    record.addCommand(cmd2);
-    record.undo();
-
-    assertEquals(-0.2, img1.getMovingHe(), 0.01);
-
-    record.redo();
-
-    assertEquals(0.1, img1.getMovingHe(), 0.01);
-  }
-
-  /**
-   * Tests {@link CommandJoin} class.
-   */
-  @Test
-  void testCommandJoinClass() {
-    CommandJoin cmd1 = new CommandJoin(img1, img2);
-    CommandJoin cmd2 = new CommandJoin(img2, img3);
-
-    record.addCommand(cmd1);
-    assertEquals(2, img1.getSequence().getImages().size());
-    assertEquals(img2, img1.next());
-    record.undo();
-    assertEquals(1, img1.getSequence().getImages().size());
-    record.redo();
-    record.addCommand(cmd2);
-    assertEquals(3, img1.getSequence().getImages().size());
-    assertEquals(img3, img1.next().next());
-  }
-
-  @Test
-  void testCommandJoinNull1() {
-    assertThrows(NullPointerException.class, () -> new CommandJoin(img1, null));
-  }
-
-  @Test
-  void commandJoinNull2() {
-    assertThrows(NullPointerException.class, () -> new CommandJoin(null, img1));
-  }
-
-  /**
-   * Tests {@link CommandUnjoin} class.
-   */
-  @Test
-  void testCommandUnjoinClass() {
-    CommandJoin join1 = new CommandJoin(img1, img2);
-    CommandJoin join2 = new CommandJoin(img2, img3);
-
-    CommandUnjoin cmd1 = new CommandUnjoin(
-            Arrays.asList(new StreetsideAbstractImage[]{img1, img2}));
-    CommandUnjoin cmd2 = new CommandUnjoin(
-            Arrays.asList(new StreetsideAbstractImage[]{img2, img3}));
-
-    record.addCommand(join1);
-    record.addCommand(join2);
-
-    record.addCommand(cmd1);
-    assertEquals(1, img1.getSequence().getImages().size());
-    record.undo();
-    assertEquals(3, img1.getSequence().getImages().size());
-    record.redo();
-    record.addCommand(cmd2);
-    assertEquals(1, img1.getSequence().getImages().size());
-    assertEquals(1, img2.getSequence().getImages().size());
-
-    CommandUnjoin command = new CommandUnjoin(Arrays.asList(new StreetsideAbstractImage[]{img1, img2, img3}));
-    assertThrows(IllegalArgumentException.class, () -> record.addCommand(command));
-  }
+    private StreetsideRecord record;
+    private StreetsideImage img1;
+    private StreetsideImage img2;
+    private StreetsideImage img3;
+
+    /**
+     * Creates a new {@link StreetsideRecord} object and 3 {@link StreetsideImage}
+     * objects.
+     */
+    @BeforeEach
+    public void setUp() {
+        record = new StreetsideRecord();
+        img1 = new StreetsideImage("key1__________________", new LatLon(0.1, 0.1), 0.1);
+        img2 = new StreetsideImage("key2__________________", new LatLon(0.2, 0.2), 0.2);
+        img3 = new StreetsideImage("key3__________________", new LatLon(0.3, 0.3), 0.3);
+        if (StreetsideLayer.hasInstance() && StreetsideLayer.getInstance().getData().getImages().size() >= 1) {
+            StreetsideLayer.getInstance().getData().getImages().clear();
+        }
+    }
+
+    /**
+     * Test commands in general.
+     */
+    @Test
+    void testCommand() {
+        StreetsideCommand cmd12 = new CommandMove(new ConcurrentSkipListSet<>(Arrays.asList(img1, img2)), 0.1, 0.1);
+        StreetsideCommand cmd23 = new CommandMove(new ConcurrentSkipListSet<>(Arrays.asList(img2, img3)), 0.1, 0.1);
+        StreetsideCommand cmd13 = new CommandMove(new ConcurrentSkipListSet<>(Arrays.asList(img1, img3)), 0.1, 0.1);
+        StreetsideCommand cmd1 = new CommandMove(new ConcurrentSkipListSet<>(Collections.singletonList(img1)), 0.1,
+                0.1);
+        StreetsideCommand cmd31 = new CommandMove(new ConcurrentSkipListSet<>(Arrays.asList(img3, img1)), 0.2, 0.2);
+        record.addCommand(cmd12);
+        record.addCommand(cmd23);
+
+        assertEquals(1, record.position);
+        assertEquals(2, record.commandList.size());
+
+        record.undo();
+
+        assertEquals(0, record.position);
+        assertEquals(2, record.commandList.size());
+
+        record.addCommand(cmd1);
+
+        assertEquals(1, record.position);
+
+        record.addCommand(cmd13);
+
+        assertEquals(2, record.position);
+        assertEquals(3, record.commandList.size());
+
+        record.undo();
+        record.redo();
+
+        assertEquals(2, record.position);
+        assertEquals(3, record.commandList.size());
+
+        record.addCommand(cmd31);
+
+        assertEquals(2, record.position);
+        assertEquals(3, record.commandList.size());
+
+        record.addCommand(cmd1);
+
+        assertEquals(3, record.position);
+        assertEquals(4, record.commandList.size());
+    }
+
+    /**
+     * Tests {@link CommandMove} class.
+     */
+    @Test
+    void testCommandMove() {
+        CommandMove cmd1 = new CommandMove(new ConcurrentSkipListSet<>(Arrays.asList(img1, img2)), 0.1, 0.1);
+        CommandMove cmd2 = new CommandMove(new ConcurrentSkipListSet<>(Arrays.asList(img1, img2)), 0.1, 0.1);
+
+        record.addCommand(cmd1);
+
+        assertEquals(0.1, img1.getMovingLatLon().lat(), 0.01);
+
+        record.undo();
+
+        assertEquals(0.0, img1.getMovingLatLon().lat(), 0.01);
+
+        record.redo();
+
+        assertEquals(0.1, img1.getMovingLatLon().lat(), 0.01);
+
+        record.addCommand(cmd2);
+        record.undo();
+
+        assertEquals(-0.1, img1.getMovingLatLon().lat(), 0.01);
+
+        record.redo();
+
+        assertEquals(0.1, img1.getMovingLatLon().lat(), 0.01);
+    }
+
+    /**
+     * Tests {@link CommandTurn} class.
+     */
+    @Test
+    void testCommandTurn() {
+        CommandTurn cmd1 = new CommandTurn(new ConcurrentSkipListSet<>(Arrays.asList(img1, img2)), 0.2);
+        CommandTurn cmd2 = new CommandTurn(new ConcurrentSkipListSet<>(Arrays.asList(img1, img2)), 0.1);
+
+        record.addCommand(cmd1);
+        record.undo();
+
+        assertEquals(-0.1, img1.getMovingHe(), 0.01);
+
+        record.redo();
+
+        assertEquals(0.1, img1.getMovingHe(), 0.01);
+
+        record.addCommand(cmd2);
+        record.undo();
+
+        assertEquals(-0.2, img1.getMovingHe(), 0.01);
+
+        record.redo();
+
+        assertEquals(0.1, img1.getMovingHe(), 0.01);
+    }
+
+    /**
+     * Tests {@link CommandJoin} class.
+     */
+    @Test
+    void testCommandJoinClass() {
+        CommandJoin cmd1 = new CommandJoin(img1, img2);
+        CommandJoin cmd2 = new CommandJoin(img2, img3);
+
+        record.addCommand(cmd1);
+        assertEquals(2, img1.getSequence().getImages().size());
+        assertEquals(img2, img1.next());
+        record.undo();
+        assertEquals(1, img1.getSequence().getImages().size());
+        record.redo();
+        record.addCommand(cmd2);
+        assertEquals(3, img1.getSequence().getImages().size());
+        assertEquals(img3, img1.next().next());
+    }
+
+    @Test
+    void testCommandJoinNull1() {
+        assertThrows(NullPointerException.class, () -> new CommandJoin(img1, null));
+    }
+
+    @Test
+    void commandJoinNull2() {
+        assertThrows(NullPointerException.class, () -> new CommandJoin(null, img1));
+    }
+
+    /**
+     * Tests {@link CommandUnjoin} class.
+     */
+    @Test
+    void testCommandUnjoinClass() {
+        CommandJoin join1 = new CommandJoin(img1, img2);
+        CommandJoin join2 = new CommandJoin(img2, img3);
+
+        CommandUnjoin cmd1 = new CommandUnjoin(Arrays.asList(new StreetsideAbstractImage[] { img1, img2 }));
+        CommandUnjoin cmd2 = new CommandUnjoin(Arrays.asList(new StreetsideAbstractImage[] { img2, img3 }));
+
+        record.addCommand(join1);
+        record.addCommand(join2);
+
+        record.addCommand(cmd1);
+        assertEquals(1, img1.getSequence().getImages().size());
+        record.undo();
+        assertEquals(3, img1.getSequence().getImages().size());
+        record.redo();
+        record.addCommand(cmd2);
+        assertEquals(1, img1.getSequence().getImages().size());
+        assertEquals(1, img2.getSequence().getImages().size());
+
+        CommandUnjoin command = new CommandUnjoin(Arrays.asList(new StreetsideAbstractImage[] { img1, img2, img3 }));
+        assertThrows(IllegalArgumentException.class, () -> record.addCommand(command));
+    }
 }
Index: applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/io/download/SequenceDownloadRunnableTest.java
===================================================================
--- applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/io/download/SequenceDownloadRunnableTest.java	(revision 36193)
+++ applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/io/download/SequenceDownloadRunnableTest.java	(revision 36194)
@@ -1,5 +1,4 @@
 // License: GPL. For details, see LICENSE file.
 package org.openstreetmap.josm.plugins.streetside.io.download;
-
 
 import static org.junit.jupiter.api.Assertions.assertEquals;
@@ -21,45 +20,48 @@
 class SequenceDownloadRunnableTest {
 
-  private static final Function<Bounds, URL> SEARCH_SEQUENCES_URL_GEN = b -> {
-    return SequenceDownloadRunnableTest.class.getResource("/api/v3/responses/searchSequences.json");
-  };
-  private Field urlGenField;
+    private static final Function<Bounds, URL> SEARCH_SEQUENCES_URL_GEN = b -> {
+        return SequenceDownloadRunnableTest.class.getResource("/api/v3/responses/searchSequences.json");
+    };
+    private Field urlGenField;
 
+    @Test
+    void testRun1() throws IllegalArgumentException, IllegalAccessException {
+        testNumberOfDecodedImages(4, SEARCH_SEQUENCES_URL_GEN, new Bounds(7.246497, 16.432955, 7.249027, 16.432976));
+    }
 
-  @Test
-  void testRun1() throws IllegalArgumentException, IllegalAccessException {
-    testNumberOfDecodedImages(4, SEARCH_SEQUENCES_URL_GEN, new Bounds(7.246497, 16.432955, 7.249027, 16.432976));
-  }
+    @Test
+    void testRun2() throws IllegalArgumentException, IllegalAccessException {
+        testNumberOfDecodedImages(0, SEARCH_SEQUENCES_URL_GEN, new Bounds(0, 0, 0, 0));
+    }
 
-  @Test
-  void testRun2() throws IllegalArgumentException, IllegalAccessException {
-    testNumberOfDecodedImages(0, SEARCH_SEQUENCES_URL_GEN, new Bounds(0, 0, 0, 0));
-  }
+    @Test
+    void testRun3() throws IllegalArgumentException, IllegalAccessException {
+        testNumberOfDecodedImages(0, b -> {
+            try {
+                return new URL("https://streetside/nonexistentURL");
+            } catch (MalformedURLException e) {
+                return null;
+            }
+        }, new Bounds(0, 0, 0, 0));
+    }
 
-  @Test
-  void testRun3() throws IllegalArgumentException, IllegalAccessException {
-    testNumberOfDecodedImages(0, b -> {
-      try { return new URL("https://streetside/nonexistentURL"); } catch (MalformedURLException e) { return null; }
-    }, new Bounds(0, 0, 0, 0));
-  }
+    @Test
+    void testRun4() throws IllegalArgumentException, IllegalAccessException {
+        StreetsideProperties.CUT_OFF_SEQUENCES_AT_BOUNDS.put(true);
+        testNumberOfDecodedImages(4, SEARCH_SEQUENCES_URL_GEN, new Bounds(7.246497, 16.432955, 7.249027, 16.432976));
+    }
 
-  @Test
-  void testRun4() throws IllegalArgumentException, IllegalAccessException {
-    StreetsideProperties.CUT_OFF_SEQUENCES_AT_BOUNDS.put(true);
-    testNumberOfDecodedImages(4, SEARCH_SEQUENCES_URL_GEN, new Bounds(7.246497, 16.432955, 7.249027, 16.432976));
-  }
+    @Test
+    void testRun5() throws IllegalArgumentException, IllegalAccessException {
+        StreetsideProperties.CUT_OFF_SEQUENCES_AT_BOUNDS.put(true);
+        testNumberOfDecodedImages(0, SEARCH_SEQUENCES_URL_GEN, new Bounds(0, 0, 0, 0));
+    }
 
-  @Test
-  void testRun5() throws IllegalArgumentException, IllegalAccessException {
-    StreetsideProperties.CUT_OFF_SEQUENCES_AT_BOUNDS.put(true);
-    testNumberOfDecodedImages(0, SEARCH_SEQUENCES_URL_GEN, new Bounds(0, 0, 0, 0));
-  }
-
-  private void testNumberOfDecodedImages(int expectedNumImgs, Function<Bounds, URL> urlGen, Bounds bounds)
-      throws IllegalArgumentException, IllegalAccessException {
-    SequenceDownloadRunnable r = new SequenceDownloadRunnable(StreetsideLayer.getInstance().getData(), bounds);
-    urlGenField.set(null, urlGen);
-    r.run();
-    assertEquals(expectedNumImgs, StreetsideLayer.getInstance().getData().getImages().size());
-  }
+    private void testNumberOfDecodedImages(int expectedNumImgs, Function<Bounds, URL> urlGen, Bounds bounds)
+            throws IllegalArgumentException, IllegalAccessException {
+        SequenceDownloadRunnable r = new SequenceDownloadRunnable(StreetsideLayer.getInstance().getData(), bounds);
+        urlGenField.set(null, urlGen);
+        r.run();
+        assertEquals(expectedNumImgs, StreetsideLayer.getInstance().getData().getImages().size());
+    }
 }
Index: applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/utils/PluginStateTest.java
===================================================================
--- applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/utils/PluginStateTest.java	(revision 36193)
+++ applications/editors/josm/plugins/MicrosoftStreetside/test/unit/org/openstreetmap/josm/plugins/streetside/utils/PluginStateTest.java	(revision 36194)
@@ -1,5 +1,4 @@
 // License: GPL. For details, see LICENSE file.
 package org.openstreetmap.josm.plugins.streetside.utils;
-
 
 import static org.junit.jupiter.api.Assertions.assertEquals;
@@ -21,43 +20,40 @@
 class PluginStateTest {
 
-  /**
-   * Test the methods related to the download.
-   */
-  @Test
-  void testDownload() {
-    assertFalse(PluginState.isDownloading());
-    PluginState.startDownload();
-    assertTrue(PluginState.isDownloading());
-    PluginState.startDownload();
-    assertTrue(PluginState.isDownloading());
-    PluginState.finishDownload();
-    assertTrue(PluginState.isDownloading());
-    PluginState.finishDownload();
-    assertFalse(PluginState.isDownloading());
-  }
+    /**
+     * Test the methods related to the download.
+     */
+    @Test
+    void testDownload() {
+        assertFalse(PluginState.isDownloading());
+        PluginState.startDownload();
+        assertTrue(PluginState.isDownloading());
+        PluginState.startDownload();
+        assertTrue(PluginState.isDownloading());
+        PluginState.finishDownload();
+        assertTrue(PluginState.isDownloading());
+        PluginState.finishDownload();
+        assertFalse(PluginState.isDownloading());
+    }
 
-  /**
-   * Tests the methods related to the upload.
-   */
-  @Test
-  void testUpload() {
-    TestUtils.assumeWorkingJMockit();
-    JOptionPaneSimpleMocker jopsMocker = new JOptionPaneSimpleMocker();
-    jopsMocker.getMockResultMap().put(
-            "You have successfully uploaded 2 images to Bing.com",
-            JOptionPane.OK_OPTION
-        );
-    assertFalse(PluginState.isUploading());
-    PluginState.addImagesToUpload(2);
-    assertEquals(2, PluginState.getImagesToUpload());
-    assertEquals(0, PluginState.getImagesUploaded());
-    assertTrue(PluginState.isUploading());
-    PluginState.imageUploaded();
-    assertEquals(1, PluginState.getImagesUploaded());
-    assertTrue(PluginState.isUploading());
-    PluginState.imageUploaded();
-    assertFalse(PluginState.isUploading());
-    assertEquals(2, PluginState.getImagesToUpload());
-    assertEquals(2, PluginState.getImagesUploaded());
-  }
+    /**
+     * Tests the methods related to the upload.
+     */
+    @Test
+    void testUpload() {
+        TestUtils.assumeWorkingJMockit();
+        JOptionPaneSimpleMocker jopsMocker = new JOptionPaneSimpleMocker();
+        jopsMocker.getMockResultMap().put("You have successfully uploaded 2 images to Bing.com", JOptionPane.OK_OPTION);
+        assertFalse(PluginState.isUploading());
+        PluginState.addImagesToUpload(2);
+        assertEquals(2, PluginState.getImagesToUpload());
+        assertEquals(0, PluginState.getImagesUploaded());
+        assertTrue(PluginState.isUploading());
+        PluginState.imageUploaded();
+        assertEquals(1, PluginState.getImagesUploaded());
+        assertTrue(PluginState.isUploading());
+        PluginState.imageUploaded();
+        assertFalse(PluginState.isUploading());
+        assertEquals(2, PluginState.getImagesToUpload());
+        assertEquals(2, PluginState.getImagesUploaded());
+    }
 }
